app/cart/urls.py
from django.urls import path
from . import views
from .views import cart_add, cart_remove, cart_detail

app_name = 'cart'


urlpatterns = [
    path('', cart_detail, name='cart_detail'),
    path('add/<int:product_id>/', cart_add, name='cart_add'),
    path('remove/<int:product_id>/', cart_remove, name='cart_remove'),
]

app/orders/urls.py
from django.urls import path
from .views import order_create


app_name = 'orders'

urlpatterns = [
    path('create/', order_create, name='order_create'),
]

app/src/urls.py
from django.contrib import admin
from django.urls import path, include
from core.views import home, about_us, buy, recommendation, contacts, add_comment, change_theme
from django.conf.urls.static import static
from django.conf import settings
# from django.utils.translation import gettext_lazy as _
from django.conf.urls.i18n import i18n_patterns


urlpatterns = i18n_patterns(
    path('admin/', admin.site.urls),
    path('home/', include('registration.urls')),
    path('catalog/', include('catalog.urls')),
    path('about_us/', about_us, name='about_us'),
    path('buy/', buy, name='buy'),
    path('recommendation/', recommendation, name='recommendation'),
    path('contacts/', contacts, name='contacts'),
    path('recommendation/add_comment', add_comment, name='add_comment'),
    path('change_theme', change_theme, name='change_theme'),
    path('cart/', include('cart.urls')),
    path('orders/', include('orders.urls')),
    path('', home, name='home'),
) + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# urlpatterns = i18n_patterns(
#     path('admin/', admin.site.urls),
#     path(_(''), home, name='home'),
#     path(_('home/'), include('registration.urls')),
#     path(_('catalog/'), include('catalog.urls')),
#     path(_('about_us/'), about_us, name='about_us'),
#     path(_('buy/'), buy, name='buy'),
#     path(_('recommendation/'), recommendation, name='recommendation'),
#     path(_('contacts/'), contacts, name='contacts'),
#     path(_('recommendation/add_comment'), add_comment, name='add_comment'),
#     path(_('change_theme'), change_theme, name='change_theme'),
#     path(_('cart/'), include('cart.urls')),
#     path(_('orders/'), include('orders.urls')),
# ) + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/cart/models.py
from django.db import models

# Create your models here.

app/core/models.py
from django.contrib.auth import get_user_model
from django.db import models
from django.utils import timezone
from django.utils.translation import ugettext_lazy as _
from phonenumber_field.modelfields import PhoneNumberField

User = get_user_model()


class Application(models.Model):
    name = models.CharField(max_length=255, verbose_name=_('Имя'))
    surname = models.CharField(max_length=255, verbose_name=_('Фамилия'))
    phone = PhoneNumberField(verbose_name=_('Телефон'))
    comment = models.TextField(max_length=255, verbose_name=_('Комментарий'))
    created = models.DateTimeField(default=timezone.now, verbose_name=_('Дата создания'))

    def __str__(self):
        return f'{self.name}, {self.surname}'

    class Meta:
        verbose_name = _('Форма')
        verbose_name_plural = _('Формы')
        ordering = ['-created']


class Recommend(models.Model):
    title = models.CharField(_('Заголовок'), max_length=100,)
    name = models.CharField(_('Имя автора'), max_length=255,)
    comment = models.TextField(_('Комментарий'), max_length=255,)
    created = models.DateTimeField(default=timezone.now,)

    def __str__(self):
        return f'{self.title}'

    class Meta:
        verbose_name = _('Отзыв')
        verbose_name_plural = _('Отзывы')
        ordering = ['-created']

app/cart/forms.py
from django import forms
from django.utils.translation import gettext_lazy as _

PRODUCT_QUANTITY_CHOICES = [(i, str(i)) for i in range(1, 21)]


class CartAddProductForm(forms.Form):
    quantity = forms.TypedChoiceField(choices=PRODUCT_QUANTITY_CHOICES, coerce=int)
    update = forms.BooleanField(required=False,
                                initial=False,
                                widget=forms.HiddenInput)

app/core/forms.py
from .models import Application, Recommend
from django.forms import ModelForm, TextInput, Textarea
from django.utils.translation import ugettext_lazy as _
from phonenumber_field.widgets import PhoneNumberInternationalFallbackWidget



class ApplicationForm(ModelForm):
    class Meta:
        model = Application
        fields = ['name', 'surname', 'phone', 'comment']

        widgets = {
            'name': TextInput(attrs={
                'placeholder': _('Имя'),
                'class': 'form-control',
            }),
            'surname': TextInput(attrs={
                'placeholder': _('Фамилия'),
                'class': 'form-control',
            }),
            'phone': PhoneNumberInternationalFallbackWidget(attrs={
                'placeholder': _('Телефон'),
                'class': 'form-control',
            }),
            'comment': Textarea(attrs={
                'placeholder': _('Комментарий'),
                'class': 'form-control',
                'rows': 5,
            })
        }


class RecommendForm(ModelForm):
    class Meta:
        model = Recommend
        fields = ['title', 'name', 'comment']

        widgets = {
            'title': TextInput(attrs={
                'class': 'form-control',
                'placeholder': _('Заголовок'),
            }),
            'name': TextInput(attrs={
                'class': 'form-control',
                'placeholder': _('Ваше имя')
            }),
            'comment': Textarea(attrs={
                'class': 'form-control',
                'placeholder': _('Комментарий')
            })
        }

app/cart/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.views.decorators.http import require_POST
from catalog.models import Product
from .cart import Cart
from .forms import CartAddProductForm


@require_POST
def cart_add(request, product_id):
    referrer = request.META['HTTP_REFERER']
    cart = Cart(request)
    product = get_object_or_404(Product, id=product_id)
    form = CartAddProductForm(request.POST)
    if form.is_valid():
        cd = form.cleaned_data
        cart.add(product=product,
                 quantity=cd['quantity'],
                 update_quantity=cd['update'])
    return redirect(referrer)


def cart_remove(request, product_id):
    cart = Cart(request)
    product = get_object_or_404(Product, id=product_id)
    cart.remove(product)
    return redirect('cart:cart_detail')


def cart_detail(request):
    cart = Cart(request)
    for item in cart:
        item['update_quantity_form'] = CartAddProductForm(initial={'quantity': item['quantity'], 'update': True})
    return render(request, 'cart/detail.html', {'cart': cart})

app/core/views.py
from django.shortcuts import render, redirect
from django.template import loader
from .forms import RecommendForm
from .models import Recommend
from core.forms import ApplicationForm
from django.core.mail import send_mail
from django.contrib import messages
from django.http import HttpResponse, HttpResponseRedirect


def home(request):
    template = loader.get_template('home.html')
    return HttpResponse(template.render({}, request))


def about_us(request):
    template = loader.get_template('about_us.html')
    return HttpResponse(template.render({}, request))


def recommendation(request):
    comments = Recommend.objects.order_by('-created')
    return render(request, 'recommends.html', {'comments': comments})


def add_comment(request):
    error = ''
    if request.method == 'POST':
        form = RecommendForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('recommendation')
        else:
            error = 'Форма заполнена неверно'

    form = RecommendForm()

    data = {
        'form': form,
        'error': error,
    }
    return render(request, 'add_comment.html', data)


def contacts(request):
    template = loader.get_template('contacts.html')
    return HttpResponse(template.render({}, request))


def buy(request):

    """ Страница с формой заявки на консультацию """

    if request.method =='POST':
        form = ApplicationForm(data=request.POST)
        if form.is_valid():
            message = 'Пользователь ' + str(form.cleaned_data['surname']) + ' ' + str(form.cleaned_data['name'])+\
                      ' \n Просит Вас перезвонить. \n Номер телефона: '+ str(form.cleaned_data['phone'])+\
                      '\n Коммантарий: \n'+str(form.cleaned_data['comment'])
            mail = send_mail('Обратный звонок!', message,
                            'polia1827@gmail.com', ['supranovich.polina@yandex.ru'], fail_silently = True)
            form.save()

            if mail:
                messages.success(request, 'Письмо отправлено')
                return redirect('buy')
            else:
                messages.error(request, 'Ошибка отправки')
        else:
            error = 'Форма заполнена неверно'
    else:
        form = ApplicationForm()

    context = {
        'form': form,
    }

    return render(request, 'application_form.html', context)


def change_theme(request):
    theme = request.POST.get('theme')
    referrer = request.META['HTTP_REFERER']
    request.session['theme'] = theme
    return redirect(referrer)

app/core/templates/cart/detail.html
{% extends "base.html" %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Корзина' %}{% endblock %}

{% block content %}
    <h1>{% trans 'Ваша корзина' %}</h1>
    <table class="table">
      <thead>
        <tr>
            <th scope="col">{% trans 'Продукт' %}</th>
            <th scope="col">{% trans 'Количество' %}</th>
            <th scope="col">{% trans 'Удалить' %}</th>
            <th scope="col">{% trans 'Цена за 1 шт' %}</th>
            <th scope="col">{% trans 'Цена' %}</th>
        </tr>
      </thead>
      <tbody>
        {% for item in cart %}
            {% with product=item.product %}
                <tr>
                     <th>
                         <a href="{{ product.get_absolute_url }}">
                             <img src="{{ product.image.url }}" alt="Card image cap" class="mr-3" alt="..." width="150" height="150">
                         </a>
                         <h6><a href="{{ product.get_absolute_url }}">{{ product.name }}</a><td>
                           {#{{ product.name }}#}
                     </th>
                    <td>
                        <form action="{% url "cart:cart_add" product.id %}" method="post">
                          {{ item.update_quantity_form.quantity }}
                            {{ item.update_quantity_form.update }}
                            <button type="submit">{% trans 'Обновить' %}</button>
                            {% csrf_token %}
                        </form>
                    </td>
                    <td>
                        <a href="{% url "cart:cart_remove" product.id%}">{% trans 'Удалить товар из корзины' %}</a>
                    </td>
                    <td>{{ item.price }} {% trans 'руб' %}</td>
                    <td>{{ item.total_price }} {% trans 'руб' %}</td>

                </tr>
            {% endwith %}
        {% endfor %}


        <tr>
           <th scope="col"></th>
           <th scope="col"></th>
           <th scope="col"></th>
           <th scope="col">{% trans 'Цена за все' %}</th>
           <th scope="col">{{ cart.get_total_price }} {% trans 'руб' %}</th>
        </tr>
      </tbody>
    </table>
        <br>
        <br>

    <p class="text-center nav_text">
        <a href="{% url "product" %}" class="btn-lg btn-light">{% trans 'Вернуться в каталог' %}</a>



        <a href="{% url "orders:order_create" %}" class="btn-lg btn-light"> {% trans 'Оформить заказ' %} </a>
    </p>
{% endblock %}